Index: /trunk/LMDZ.GENERIC/libf/phystd/vdifc.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/vdifc.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/vdifc.F	(revision 253)
@@ -379,244 +381,343 @@
       ENDDO
 
-      DO ilay=nlay-1,1,-1
+      DO ilay=nlay-1,2,-1
          DO ig=1,ngrid
             z1(ig)=1./(za(ig,ilay)+zb(ig,ilay)+
-     $         zb(ig,ilay+1)*(1.-zd(ig,ilay+1)))
+     &           zb(ig,ilay+1)*(1.-zd(ig,ilay+1)))
             zc(ig,ilay)=(za(ig,ilay)*zh(ig,ilay)+
-     $         zb(ig,ilay+1)*zc(ig,ilay+1))*z1(ig)
+     &           zb(ig,ilay+1)*zc(ig,ilay+1))*z1(ig)
             zd(ig,ilay)=zb(ig,ilay)*z1(ig)
          ENDDO
       ENDDO
 
-c    ** calcul de (d Planck / dT) a la temperature d'interface
-c       ------------------------------------------------------
-
-      z4st=4.*5.67e-8*ptimestep
+      DO ig=1,ngrid
+         z1(ig)=1./(za(ig,1)+zb(ig,1)+
+     &        zb(ig,2)*(1.-zd(ig,2)))
+         zc(ig,1)=(za(ig,1)*zh(ig,1)+
+     &        zb(ig,2)*zc(ig,2))*z1(ig)
+         zd(ig,1)=zb(ig,1)*z1(ig)
+      ENDDO
+
+!     Calculate (d Planck / dT) at the interface temperature
+!     ------------------------------------------------------
+
+      z4st=4.0*sigma*ptimestep
       DO ig=1,ngrid
          zdplanck(ig)=z4st*pemis(ig)*ptsrf(ig)*ptsrf(ig)*ptsrf(ig)
       ENDDO
 
-c    ** calcul de la temperature_d'interface et de sa tendance.
-c       on ecrit que la somme des flux est nulle a l'interface
-c       a t + \delta t,
-c       c'est a dire le flux radiatif a {t + \delta t}
-c       + le flux turbulent a {t + \delta t} 
-c            qui s'ecrit K (T1-Tsurf) avec T1 = d1 Tsurf + c1
-c            (notation K dt = /cpp*b/)        
-c       + le flux dans le sol a t
-c       + l'evolution du flux dans le sol lorsque la temperature d'interface
-c       passe de sa valeur a t a sa valeur a {t + \delta t}.
-c       ----------------------------------------------------
-
-      DO ig=1,ngrid
-         z1(ig)=pcapcal(ig)*ptsrf(ig)+cpp*zb(ig,1)*zc(ig,1)
-     s     +zdplanck(ig)*ptsrf(ig)+ pfluxsrf(ig)*ptimestep
-         z2(ig)= pcapcal(ig)+cpp*zb(ig,1)*(1.-zd(ig,1))+zdplanck(ig)
-         ztsrf2(ig)=z1(ig)/z2(ig)
-         pdtsrf(ig)=(ztsrf2(ig)-ptsrf(ig))/ptimestep
-
-c        Modif speciale CO2 condensation:
-c        tconds = 1./(bcond-acond*log(.0095*pplev(ig,1)))
-c        if ((callcond).and.
-c    &      ((co2ice(ig).ne.0).or.(ztsrf2(ig).lt.tconds)))then
-c           zh(ig,1)=zc(ig,1)+zd(ig,1)*tconds
-c        else
-            zh(ig,1)=zc(ig,1)+zd(ig,1)*ztsrf2(ig)
-c        end if
-      ENDDO
-
-c    ** et a partir de la temperature au sol on remonte 
-c       -----------------------------------------------
-
-      DO ilay=2,nlay
-         DO ig=1,ngrid
-            hh = max( zh(ig,ilay-1) , zhcond(ig,ilay-1) ) ! modif co2cond
-            zh(ig,ilay)=zc(ig,ilay)+zd(ig,ilay)*hh
-         ENDDO
-      ENDDO
-
-
-c-----------------------------------------------------------------------
-c   TRACERS
-c   -------
+!     Calculate temperature tendency at the interface (dry case)
+!     ----------------------------------------------------------
+!     Sum of fluxes at interface at time t + \delta t gives change in T:
+!       radiative fluxes
+!       turbulent convective (sensible) heat flux
+!       flux (if any) from subsurface
+
+      if(.not.water) then
+
+         DO ig=1,ngrid
+
+            z1(ig) = pcapcal(ig)*ptsrf(ig) + cpp*zb(ig,1)*zc(ig,1)
+     &           + zdplanck(ig)*ptsrf(ig) + pfluxsrf(ig)*ptimestep
+            z2(ig) = pcapcal(ig) + cpp*zb(ig,1)*(1.-zd(ig,1)) 
+     &           +zdplanck(ig)
+            ztsrf2(ig) = z1(ig) / z2(ig)
+            pdtsrf(ig) = (ztsrf2(ig) - ptsrf(ig))/ptimestep
+            zh(ig,1)   = zc(ig,1) + zd(ig,1)*ztsrf2(ig)
+         ENDDO
+
+!     Recalculate temperature to top of atmosphere, starting from ground
+!     ------------------------------------------------------------------
+
+         DO ilay=2,nlay
+            DO ig=1,ngrid
+               hh = zh(ig,ilay-1)
+               zh(ig,ilay)=zc(ig,ilay)+zd(ig,ilay)*hh
+            ENDDO
+         ENDDO
+
+      endif                     ! not water
+
+!-----------------------------------------------------------------------
+!     TRACERS (no vapour)
+!     -------
 
       if(tracer) then
 
-c     Using the wind modified by friction for lifting and  sublimation
-c     ----------------------------------------------------------------
-        DO ig=1,ngrid
-          zu2=zu(ig,1)*zu(ig,1)+zv(ig,1)*zv(ig,1)
-          zcdv(ig)=zcdv_true(ig)*sqrt(zu2)
-          zcdh(ig)=zcdh_true(ig)*sqrt(zu2)
-        ENDDO
-
-c       Calcul du flux vertical au bas de la premiere couche (dust) :
-c       -----------------------------------------------------------
-        do ig=1,ngridmx  
-          rho(ig) = zb0(ig,1) /ptimestep
-!          zb(ig,1) = 0.
-        end do
-
-        call zerophys(ngrid*nq,pdqsdif)
-
-c       OU calcul de la valeur de q a la surface (water)  :
-c       ----------------------------------------
-        if (water) then
-           !call watersat(ngridmx,ptsrf,pplev(1,1),qsat)
-           do ig=1,ngridmx  
-              call watersat_2(ptsrf(ig),pplev(ig,1),qsat(ig))
-           end do
-        end if
-
-c      Inversion pour l'implicite sur q 
-c       --------------------------------
-        do iq=1,nq 
-          CALL multipl((nlay-1)*ngrid,zkh(1,2),zb0(1,2),zb(1,2))
-
-          if ((water).and.(iq.eq.igcm_h2o_vap)) then 
-c            This line is required to account for turbulent transport 
-c            from surface (e.g. ice) to mid-layer of atmosphere:
-             CALL multipl(ngrid,zcdv,zb0,zb(1,1))
-             CALL multipl(ngrid,dryness,zb(1,1),zb(1,1)) 
-          else ! (re)-initialize zb(:,1)
-             zb(1:ngrid,1)=0
-          end if
-
-          DO ig=1,ngrid
-               z1(ig)=1./(za(ig,nlay)+zb(ig,nlay))
-               zc(ig,nlay)=za(ig,nlay)*zq(ig,nlay,iq)*z1(ig)
-               zd(ig,nlay)=zb(ig,nlay)*z1(ig)
-          ENDDO 
-  
-          DO ilay=nlay-1,2,-1
+!     Calculate vertical flux from the bottom to the first layer (dust)
+!     -----------------------------------------------------------------
+         do ig=1,ngridmx  
+            rho(ig) = zb0(ig,1) /ptimestep
+         end do
+
+         call zerophys(ngrid*nq,pdqsdif)
+
+!     Implicit inversion of q
+!     -----------------------
+         do iq=1,nq 
+
+            if (iq.ne.igcm_h2o_vap) then
+
                DO ig=1,ngrid
-                z1(ig)=1./(za(ig,ilay)+zb(ig,ilay)+
-     $           zb(ig,ilay+1)*(1.-zd(ig,ilay+1)))
-                zc(ig,ilay)=(za(ig,ilay)*zq(ig,ilay,iq)+
-     $           zb(ig,ilay+1)*zc(ig,ilay+1))*z1(ig)
-                zd(ig,ilay)=zb(ig,ilay)*z1(ig)
+                  z1(ig)=1./(za(ig,nlay)+zb(ig,nlay))
+                  zcq(ig,nlay)=za(ig,nlay)*zq(ig,nlay,iq)*z1(ig)
+                  zdq(ig,nlay)=zb(ig,nlay)*z1(ig)
+               ENDDO 
+            
+               DO ilay=nlay-1,2,-1
+                  DO ig=1,ngrid
+                     z1(ig)=1./(za(ig,ilay)+zb(ig,ilay)+
+     &                    zb(ig,ilay+1)*(1.-zdq(ig,ilay+1)))
+                     zcq(ig,ilay)=(za(ig,ilay)*zq(ig,ilay,iq)+
+     &                    zb(ig,ilay+1)*zcq(ig,ilay+1))*z1(ig)
+                     zdq(ig,ilay)=zb(ig,ilay)*z1(ig)
+                  ENDDO
                ENDDO
-          ENDDO
-
-          if (water.and.(iq.eq.igcm_h2o_ice)) then
-            ! special case for water ice tracer: do not include
-            ! h2o ice tracer from surface (which is set when handling
-            ! h2o vapour case (see further down).
-            DO ig=1,ngrid
-                z1(ig)=1./(za(ig,1)+zb(ig,1)+
-     $           zb(ig,2)*(1.-zd(ig,2)))
-                zc(ig,1)=(za(ig,1)*zq(ig,1,iq)+
-     $         zb(ig,2)*zc(ig,2)) *z1(ig)
-            ENDDO
-          else ! general case
-            DO ig=1,ngrid
-                z1(ig)=1./(za(ig,1)+zb(ig,1)+
-     $           zb(ig,2)*(1.-zd(ig,2)))
-                zc(ig,1)=(za(ig,1)*zq(ig,1,iq)+
-     $         zb(ig,2)*zc(ig,2) +
-     $        (-pdqsdif(ig,iq)) *ptimestep) *z1(ig)  !tracer flux from surface
-            ENDDO
-          endif ! of if (water.and.(iq.eq.igcm_h2o_ice))
-  
-          IF ((water).and.(iq.eq.igcm_h2o_vap)) then 
-c           Calculation for turbulent exchange with the surface (for ice)
-            DO ig=1,ngrid
-              zd(ig,1)=zb(ig,1)*z1(ig)
-              zq1temp(ig)=zc(ig,1)+ zd(ig,1)*qsat(ig)
-
-              pdqsdif(ig,igcm_h2o_ice)=rho(ig)*dryness(ig)*zcdv(ig)
-     &                       *(zq1temp(ig)-qsat(ig))
-c             write(*,*)'flux vers le sol=',pdqsdif(ig,nq)
-            END DO
-
-            DO ig=1,ngrid
-              if(.not.watercaptag(ig)) then
-                if ((-pdqsdif(ig,igcm_h2o_ice)*ptimestep)
-     &             .gt.pqsurf(ig,igcm_h2o_ice)) then
-c                 write(*,*)'on sublime plus que qsurf!'
-                  pdqsdif(ig,igcm_h2o_ice)=
-     &                         -pqsurf(ig,igcm_h2o_ice)/ptimestep
-c                 write(*,*)'flux vers le sol=',pdqsdif(ig,nq)
-                  z1(ig)=1./(za(ig,1)+ zb(ig,2)*(1.-zd(ig,2)))
-                  zc(ig,1)=(za(ig,1)*zq(ig,1,igcm_h2o_vap)+
-     $            zb(ig,2)*zc(ig,2) +
-     $            (-pdqsdif(ig,igcm_h2o_ice)) *ptimestep) *z1(ig)
-                  zq1temp(ig)=zc(ig,1)
-                endif   
-              endif ! if (.not.watercaptag(ig))
-c             Starting upward calculations for water :
-               zq(ig,1,igcm_h2o_vap)=zq1temp(ig)
-            ENDDO ! of DO ig=1,ngrid
-
-
-!            ! ADDED BY RW: Water latent heat effect 
-!     this doesnt work; causes instability. What do they do on earth?
-!            DO ig=1,ngrid
-!               pdtsrf(ig)= 
-!     &             pdtsrf(ig)+RLVTT*pdqsdif(ig,igcm_h2o_ice)/pcapcal(ig)
-!            ENDDO
-!            print*,'Surface latent heat release in vdifc'
-!            print*,'due to H2O NOT taken into account.'
-
-          ELSE
-c           Starting upward calculations for simple mixing of tracer (dust)
-            DO ig=1,ngrid
-               zq(ig,1,iq)=zc(ig,1)
-            ENDDO
-          END IF ! of IF ((water).and.(iq.eq.igcm_h2o_vap))
-
-          DO ilay=2,nlay
-             DO ig=1,ngrid
-                zq(ig,ilay,iq)=zc(ig,ilay)+zd(ig,ilay)*zq(ig,ilay-1,iq)
-             ENDDO
-          ENDDO
-        enddo ! of do iq=1,nq
-      end if ! of if(tracer)
-
-c-----------------------------------------------------------------------
-c   8. calcul final des tendances de la diffusion verticale
-c      ----------------------------------------------------
-
-      DO ilev = 1, nlay
-         DO ig=1,ngrid
-            pdudif(ig,ilev)=(    zu(ig,ilev)-
-     $      (pu(ig,ilev)+pdufi(ig,ilev)*ptimestep)    )/ptimestep
-            pdvdif(ig,ilev)=(    zv(ig,ilev)-
-     $      (pv(ig,ilev)+pdvfi(ig,ilev)*ptimestep)    )/ptimestep
-            hh = max(ph(ig,ilev)+pdhfi(ig,ilev)*ptimestep ,
-     $           zhcond(ig,ilev))        ! modif co2cond
+
+               if ((water).and.(iq.eq.iice)) then
+                  ! special case for water ice tracer: do not include
+                  ! h2o ice tracer from surface (which is set when handling
+                  ! h2o vapour case (see further down).
+                  ! zb(ig,1)=0 if iq ne ivap
+                  DO ig=1,ngrid
+                     z1(ig)=1./(za(ig,1)+
+     &                    zb(ig,2)*(1.-zdq(ig,2)))
+                     zcq(ig,1)=(za(ig,1)*zq(ig,1,iq)+
+     &                    zb(ig,2)*zcq(ig,2))*z1(ig)
+                  ENDDO
+               else             ! general case
+                  DO ig=1,ngrid
+                     z1(ig)=1./(za(ig,1)+
+     &                    zb(ig,2)*(1.-zdq(ig,2)))
+                     zcq(ig,1)=(za(ig,1)*zq(ig,1,iq)+
+     &                    zb(ig,2)*zcq(ig,2)
+     &                    +(-pdqsdif(ig,iq))*ptimestep)*z1(ig)
+                          ! tracer flux from surface
+                          ! currently pdqsdif always zero here,
+                          ! so last line is superfluous
+                  enddo
+               endif            ! of if (water.and.(iq.eq.igcm_h2o_ice))
+
+
+!     Starting upward calculations for simple tracer mixing (e.g., dust)
+               do ig=1,ngrid
+                  zq(ig,1,iq)=zcq(ig,1)
+               end do
+
+               do ilay=2,nlay
+                  do ig=1,ngrid
+                     zq(ig,ilay,iq)=zcq(ig,ilay)+
+     $                    zdq(ig,ilay)*zq(ig,ilay-1,iq)
+                  end do
+               end do
+
+            endif               ! if (iq.ne.igcm_h2o_vap)
+
+!     Calculate temperature tendency including latent heat term
+!     and assuming an infinite source of water on the ground
+!     ------------------------------------------------------------------
+
+            if (water.and.(iq.eq.igcm_h2o_vap)) then 
+            
+               ! compute evaporation efficiency
+               do ig = 1, ngrid
+                  if(rnat(ig).eq.1)then
+                     dryness(ig)=pqsurf(ig,ivap)+pqsurf(ig,iice) 
+                     dryness(ig)=MIN(1.,2*dryness(ig)/mx_eau_sol)
+                     dryness(ig)=MAX(0.,dryness(ig))
+                  endif
+               enddo
+
+               do ig=1,ngrid
+
+                ! Calculate the value of qsat at the surface (water)
+                call watersat(ptsrf(ig),pplev(ig,1),qsat(ig))
+                call watersat(ptsrf(ig)-0.0001,pplev(ig,1),qsat_temp1)
+                call watersat(ptsrf(ig)+0.0001,pplev(ig,1),qsat_temp2)
+                dqsat(ig)=(qsat_temp2-qsat_temp1)/0.0002
+                ! calculate dQsat / dT by finite differences
+                ! we cannot use the updated temperature value yet...
+ 
+               enddo
+
+! coefficients for q
+
+               do ig=1,ngrid
+                  z1(ig)=1./(za(ig,nlay)+zb(ig,nlay))
+                  zcq(ig,nlay)=za(ig,nlay)*zq(ig,nlay,iq)*z1(ig)
+                  zdq(ig,nlay)=zb(ig,nlay)*z1(ig)
+               enddo 
+            
+               do ilay=nlay-1,2,-1
+                  do ig=1,ngrid
+                     z1(ig)=1./(za(ig,ilay)+zb(ig,ilay)+
+     $                    zb(ig,ilay+1)*(1.-zdq(ig,ilay+1)))
+                     zcq(ig,ilay)=(za(ig,ilay)*zq(ig,ilay,iq)+
+     $                    zb(ig,ilay+1)*zcq(ig,ilay+1))*z1(ig)
+                     zdq(ig,ilay)=zb(ig,ilay)*z1(ig)
+                  enddo
+               enddo
+
+               do ig=1,ngrid
+                  z1(ig)=1./(za(ig,1)+zb(ig,1)*dryness(ig)+
+     $                 zb(ig,2)*(1.-zdq(ig,2)))
+                  zcq(ig,1)=(za(ig,1)*zq(ig,1,iq)+
+     $                 zb(ig,2)*zcq(ig,2))*z1(ig)
+                  zdq(ig,1)=dryness(ig)*zb(ig,1)*z1(ig)
+               enddo
+
+! calculation of h0 and h1
+               do ig=1,ngrid
+                  zdq0(ig) = dqsat(ig)
+                  zcq0(ig) = qsat(ig)-dqsat(ig)*ptsrf(ig)
+
+                  z1(ig) = pcapcal(ig)*ptsrf(ig) +cpp*zb(ig,1)*zc(ig,1)
+     &                 + zdplanck(ig)*ptsrf(ig) + pfluxsrf(ig)*ptimestep 
+     &                 +  zb(ig,1)*dryness(ig)*RLVTT*
+     &                 ((zdq(ig,1)-1.0)*zcq0(ig)+zcq(ig,1))
+
+                  z2(ig) = pcapcal(ig) + cpp*zb(ig,1)*(1.-zd(ig,1))
+     &                 +zdplanck(ig)
+     &                 +zb(ig,1)*dryness(ig)*RLVTT*zdq0(ig)*
+     &                 (1.0-zdq(ig,1))
+
+                  ztsrf2(ig) = z1(ig) / z2(ig)
+                  pdtsrf(ig) = (ztsrf2(ig) - ptsrf(ig))/ptimestep
+                  zh(ig,1)   = zc(ig,1) + zd(ig,1)*ztsrf2(ig)
+               enddo
+
+! calculation of qs and q1
+               do ig=1,ngrid
+                  zq0(ig)     = zcq0(ig)+zdq0(ig)*ztsrf2(ig)
+                  zq(ig,1,iq) = zcq(ig,1)+zdq(ig,1)*zq0(ig)
+               enddo
+
+! calculation of evaporation              
+               do ig=1,ngrid 
+                  evap(ig)= zb(ig,1)*dryness(ig)*(zq(ig,1,ivap)-zq0(ig))
+                  dqsdif_total(ig)=evap(ig)
+               enddo
+
+! recalculate temperature and q(vap) to top of atmosphere, starting from ground
+               do ilay=2,nlay
+                  do ig=1,ngrid
+                     zq(ig,ilay,iq)=zcq(ig,ilay)
+     &                    +zdq(ig,ilay)*zq(ig,ilay-1,iq)
+                     zh(ig,ilay)=zc(ig,ilay)+zd(ig,ilay)*zh(ig,ilay-1)
+                  end do
+               end do
+
+               do ig=1,ngrid
+
+!     --------------------------------------------------------------------------
+!     On the ocean, if T > 0 C then the vapour tendency must replace the ice one
+!     The surface vapour tracer is actually liquid. To make things difficult.
+
+                  if (rnat(ig).eq.0) then ! unfrozen ocean
+                     
+                     pdqsdif(ig,ivap)=dqsdif_total(ig)/ptimestep
+                     pdqsdif(ig,iice)=0.0
+
+
+                  elseif (rnat(ig).eq.1) then ! (continent)
+
+!     --------------------------------------------------------
+!     Now check if we've taken too much water from the surface
+!     This can only occur on the continent 
+
+!     If water is evaporating / subliming, we take it from ice before liquid
+!     -- is this valid??
+                     if(dqsdif_total(ig).lt.0)then
+                        pdqsdif(ig,iice)=dqsdif_total(ig)/ptimestep
+                        pdqsdif(ig,iice)=max(-pqsurf(ig,iice)/ptimestep
+     &                       ,pdqsdif(ig,iice))
+                     endif
+                     ! sublimation only greater than qsurf(ice)
+                     ! ----------------------------------------
+                     ! we just convert some liquid to vapour too
+                     ! if latent heats are the same, no big deal
+                     if (-dqsdif_total(ig).gt.pqsurf(ig,iice))then            
+                       pdqsdif(ig,iice) = -pqsurf(ig,iice)/ptimestep ! removes all the ice!
+                       pdqsdif(ig,ivap) = dqsdif_total(ig)/ptimestep
+     &                       - pdqsdif(ig,iice) ! take the remainder from the liquid instead
+                       pdqsdif(ig,ivap) = max(-pqsurf(ig,ivap)/ptimestep
+     &                       ,pdqsdif(ig,ivap))
+                    endif
+
+                 endif          ! if (rnat.ne.1)
+
+!     If water vapour is condensing, we must decide whether it forms ice or liquid.
+                 if(dqsdif_total(ig).gt.0)then ! a bug was here!
+                    if(ztsrf2(ig).gt.To)then
+                       pdqsdif(ig,iice)=0.0
+                       pdqsdif(ig,ivap)=dqsdif_total(ig)/ptimestep
+                    else
+                       pdqsdif(ig,iice)=dqsdif_total(ig)/ptimestep
+                       pdqsdif(ig,ivap)=0.0
+                    endif
+                 endif
+
+              end do            ! of DO ig=1,ngrid
+           endif                ! if (water et iq=ivap)
+        end do                  ! of do iq=1,nq
+      endif                     ! traceur
+
+
+!-----------------------------------------------------------------------
+!     8. Final calculation of the vertical diffusion tendencies
+!     -----------------------------------------------------------------
+
+      do ilev = 1, nlay
+         do ig=1,ngrid
+            pdudif(ig,ilev)=(zu(ig,ilev)-
+     &           (pu(ig,ilev)+pdufi(ig,ilev)*ptimestep))/ptimestep
+            pdvdif(ig,ilev)=(zv(ig,ilev)-
+     &           (pv(ig,ilev)+pdvfi(ig,ilev)*ptimestep))/ptimestep
+            hh = ph(ig,ilev)+pdhfi(ig,ilev)*ptimestep 
+
             pdhdif(ig,ilev)=( zh(ig,ilev)- hh )/ptimestep
-         ENDDO
-      ENDDO
-
-    
-      if (tracer) then 
-        DO iq = 1, nq
-          DO ilev = 1, nlay
-            DO ig=1,ngrid
-              pdqdif(ig,ilev,iq)=(zq(ig,ilev,iq)-
-     $      (pq(ig,ilev,iq) + pdqfi(ig,ilev,iq)*ptimestep))/ptimestep
-            ENDDO
-          ENDDO
-        ENDDO
-      end if
-
-c    ** diagnostique final 
-c       ------------------
-
-      IF(lecrit) THEN
-         PRINT*,'In vdif'
-         PRINT*,'Ts (t) and Ts (t+st)'
-         WRITE(*,'(a10,3a15)')
-     s   'theta(t)','theta(t+dt)','u(t)','u(t+dt)'
-         PRINT*,ptsrf(ngrid/2+1),ztsrf2(ngrid/2+1)
-         DO ilev=1,nlay
-            WRITE(*,'(4f15.7)')
-     s      ph(ngrid/2+1,ilev),zh(ngrid/2+1,ilev),
-     s      pu(ngrid/2+1,ilev),zu(ngrid/2+1,ilev)
-
-         ENDDO
-      ENDIF
-
-      RETURN
-      END
+         enddo
+      enddo
+      
+      if (tracer) then
+         do iq = 1, nq
+            do ilev = 1, nlay
+               do ig=1,ngrid
+                  pdqdif(ig,ilev,iq)=(zq(ig,ilev,iq)-
+     &           (pq(ig,ilev,iq)+pdqfi(ig,ilev,iq)*ptimestep))/
+     &           ptimestep
+               enddo
+            enddo
+         enddo
+
+         if(water.and.forceWC)then ! force water conservation in model
+                                   ! we calculate the difference and add it to the ground
+                                   ! this is ugly and should be improved in the future
+            do ig=1,ngrid
+               Wtot=0.0
+               do ilay=1,nlay
+                  masse = (pplev(ig,ilay) - pplev(ig,ilay+1))/g
+!                  Wtot=Wtot+masse*(zq(ig,ilay,iice)-
+!     &                 (pq(ig,ilay,iice)+pdqfi(ig,ilay,iice)*ptimestep))
+                  Wtot=Wtot+masse*(zq(ig,ilay,ivap)-
+     &                 (pq(ig,ilay,ivap)+pdqfi(ig,ilay,ivap)*ptimestep))
+               enddo
+               Wdiff=Wtot/ptimestep+pdqsdif(ig,ivap)+pdqsdif(ig,iice)
+
+               if(ztsrf2(ig).gt.To)then
+                  pdqsdif(ig,ivap)=pdqsdif(ig,ivap)-Wdiff
+               else
+                  pdqsdif(ig,iice)=pdqsdif(ig,iice)-Wdiff
+               endif
+            enddo
+
+         endif
+
+      endif 
+
+      if(water)then
+      call writediagfi(ngrid,'beta','Dryness coefficient',' ',2,dryness)
+      endif
+
+      return
+      end
Index: /trunk/LMDZ.GENERIC/libf/phystd/watercap.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/watercap.h	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/watercap.h	(revision 253)
@@ -1,4 +1,4 @@
-c-----------------------------------------------------------------------
-c INCLUDE 'watercap.h'
+!-----------------------------------------------------------------------
+! INCLUDE 'watercap.h'
 
       logical watercaptag(ngridmx)
Index: /trunk/LMDZ.GENERIC/libf/phystd/watercommon_h.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/watercommon_h.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/watercommon_h.F90	(revision 253)
@@ -6,5 +6,15 @@
       real, parameter :: To = 273.16
       real, parameter :: mH2O = 18.01528   
-      real, parameter :: RLVTT = 2.5008E+6 ! Latent heat of sublimation (J kg-1) 
+
+      ! benjamin additions
+      real, parameter :: RLVTT = 2.257E+6 ! Latent heat of sublimation (J kg-1) 
+      real, parameter :: RLSTT = 2.257E+6 ! 2.591E+6 in reality ! Latent heat of sublimation (J kg-1)
+      !real, parameter :: RLVTT = 0.0 
+      !real, parameter :: RLSTT = 0.0
+
+      real, parameter :: RLFTT = 3.334E+5 ! Latent heat of fusion (J kg-1) 
+      !real, parameter :: RLFTT = 0.0 
+      real, parameter :: rhowater = 1.0E+3 ! mass of water (kg/m^3)
+      real, parameter :: mx_eau_sol = 150 ! mass of water (kg/m^2)
 
 !     This was the old Martian latent heat version:
Index: /trunk/LMDZ.GENERIC/libf/phystd/watersat.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/watersat.F90	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/watersat.F90	(revision 253)
@@ -0,0 +1,41 @@
+subroutine watersat(T,p,qsat)
+
+  use watercommon_h, only: To, epsi
+  implicit none
+
+!==================================================================
+!     Purpose
+!     -------
+!     Compute the water mass mixing ratio at saturation (kg/kg)
+!     for a given pressure (Pa) and temperature (K)
+!     A replacement for the old watersat.F in the Martian GCM.
+!     Based on FCTTRE.h in the LMDTERRE model.
+!
+!     Authors
+!     -------
+!     Robin Wordsworth (2010)
+!
+!==================================================================
+
+!   input
+  real T, p
+  
+!   output
+  real qsat
+
+! checked vs. NIST data 22/06/2010 by RW.
+! / by p gives partial pressure
+! x by epsi converts to mass mixing ratio
+
+  if (T.lt.To) then ! solid / vapour
+     qsat = 100.0 * epsi * 10**(2.07023 - 0.00320991             &
+          * T - 2484.896 / T + 3.56654 * alog10(T))
+  else                 ! liquid / vapour
+     qsat = 100.0 * epsi * 10**(23.8319 - 2948.964 / T - 5.028  &
+          * alog10(T) - 29810.16 * exp( -0.0699382 * T)  &
+          + 25.21935 * exp(-2999.924/T))
+  endif
+  qsat=qsat/p
+
+  return
+end subroutine watersat
Index: /trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/writediagfi.F	(revision 253)
@@ -6,5 +6,5 @@
 !  0d (pour un scalaire qui ne depend que du temps : ex : la longitude
 !  solaire)
-!  (ou encore 1d, dans le cas de testphys1d, pour sortir une colonne)
+!  (ou encore 1d, dans le cas de rcm1d, pour sortir une colonne)
 !  La periode d'ecriture est donnee par 
 !  "ecritphy " regle dans le fichier de controle de run :  run.def
@@ -149,5 +149,5 @@
 
       if (ngridmx.eq.1) then
-        ! in testphys1d, for the 1d version of the GCM, iphysiq and irythme
+        ! in rcm1d, for the 1d version of the GCM, iphysiq and irythme
         ! are undefined; so set them to 1
         iphysiq=1 
Index: /trunk/LMDZ.GENERIC/liste_des_sources_f77
===================================================================
--- /trunk/LMDZ.GENERIC/liste_des_sources_f77	(revision 252)
+++ /trunk/LMDZ.GENERIC/liste_des_sources_f77	(revision 253)
@@ -179,34 +179,37 @@
 libf/filtrez/jacobi.F
 libf/filtrez/parafilt.h
-libf/grid/fxyprim.h
 libf/grid/fxy_new.h
 libf/grid/fxy_reg.h
 libf/grid/fxy_sin.h
+libf/grid/fxyprim.h
 libf/grid/dimensions.h
 libf/grid/bands.h
 libf/phystd/aerave.F
+libf/phystd/aerave_new.F
 libf/phystd/blackl.F
-libf/phystd/physiq.F
-libf/phystd/callcorrk.F
-libf/phystd/tracer.h
 libf/phystd/callkeys.h
+libf/phystd/callsedim.F
 libf/phystd/comcstfi.h
-libf/phystd/cvmgp.F
 libf/phystd/comdiurn.h
 libf/phystd/comg1d.h
 libf/phystd/comgeomfi.h
-libf/phystd/solarlong.F
 libf/phystd/comsaison.h
+libf/phystd/comsoil.h
 libf/phystd/convadj.F
+libf/phystd/cpdet.F
+libf/phystd/cpdet.h
+libf/phystd/cvmgp.F
 libf/phystd/cvmgt.F
-libf/phystd/lagrange.F
 libf/phystd/datafile.h
 libf/phystd/datareadnc.F
 libf/phystd/dimphys.h
-libf/phystd/tabfi.F
+libf/phystd/dsolver.F
+libf/phystd/dtridgl.F
+libf/phystd/evap.F
 libf/phystd/fisice.h
-libf/phystd/optcv.F
-libf/phystd/phyetat0.F
-libf/phystd/planete.h
+libf/phystd/forceWCfn.F
+libf/phystd/gases.h
+libf/phystd/gfluxi.F
+libf/phystd/gfluxv.F
 libf/phystd/inifis.F
 libf/phystd/iniorbit.F
@@ -214,43 +217,41 @@
 libf/phystd/initracer.F
 libf/phystd/iniwrite.F
+libf/phystd/iniwrite_spec.F
+libf/phystd/interp_line.F
 libf/phystd/ismax.F
 libf/phystd/ismin.F
-libf/phystd/physdem1.F
+libf/phystd/lagrange.F
+libf/phystd/largescale.F
 libf/phystd/mucorr.F
 libf/phystd/mufract.F
 libf/phystd/multipl.F
+libf/phystd/newsedim.F
+libf/phystd/orbite.F
+libf/phystd/phyetat0.F
+libf/phystd/physdem1.F
+libf/phystd/planete.h
+libf/phystd/profile.F
+libf/phystd/rcm1d.F
+libf/phystd/scopyi.F
+libf/phystd/sfluxi.F
 libf/phystd/sfluxv.F
-libf/phystd/orbite.F
-libf/phystd/profile.F
-libf/phystd/scopyi.F
+libf/phystd/soil.F
+libf/phystd/soil_settings.F
+libf/phystd/statto.h
+libf/phystd/stelang.F
+libf/phystd/stellarlong.F
+libf/phystd/surface_nature.F
+libf/phystd/surfdat.h
 libf/phystd/surfini.F
+libf/phystd/tabfi.F
+libf/phystd/tpindex.F
+libf/phystd/tracer.h
 libf/phystd/vdifc.F
-libf/phystd/soil.F
-libf/phystd/solang.F
-libf/phystd/statto.h
-libf/phystd/surfdat.h
 libf/phystd/vdif_cd.F
 libf/phystd/vdif_kc.F
 libf/phystd/vlz_fi.F
 libf/phystd/watercap.h
-libf/phystd/comsoil.h
 libf/phystd/writediagfi.F
+libf/phystd/writediagspec.F
 libf/phystd/writeg1d.F
 libf/phystd/zerophys.F
-libf/phystd/callsedim.F
-libf/phystd/interp_line.F
-libf/phystd/soil_settings.F
-libf/phystd/sfluxi.F
-libf/phystd/tpindex.F
-libf/phystd/gfluxv.F
-libf/phystd/gfluxi.F
-libf/phystd/dsolver.F
-libf/phystd/dtridgl.F
-libf/phystd/co2snow.F
-libf/phystd/testphys1d.F
-libf/phystd/kastprof_fn.F
-libf/phystd/newsedim.F
-libf/phystd/aerave_new.F
-libf/phystd/iniwrite_spec.F
-libf/phystd/writediagspec.F
-libf/phystd/largescale2.F
Index: /trunk/LMDZ.GENERIC/liste_des_sources_f90
===================================================================
--- /trunk/LMDZ.GENERIC/liste_des_sources_f90	(revision 252)
+++ /trunk/LMDZ.GENERIC/liste_des_sources_f90	(revision 253)
@@ -3,27 +3,38 @@
 libf/bibio/ioipsl_stringop.F90
 libf/phystd/aeropacity.F90
+libf/phystd/aeroptproperties.F90
+libf/phystd/ave_stelspec.F90
+libf/phystd/calc_cpp3d.F90
+libf/phystd/calc_cpp_mugaz.F90
+libf/phystd/calc_rayleigh.F90
+libf/phystd/callcorrk.F90
+libf/phystd/condens_co2cloud.F90
+libf/phystd/def_var.F90
+libf/phystd/hydrol.F90
+libf/phystd/iniwritesoil.F90
+libf/phystd/interpolateH2H2.F90
+libf/phystd/kastprof_fn.F90
+libf/phystd/mkstat.F90
+libf/phystd/moistadj.F90
+libf/phystd/N2broadprof_fn.F90
+libf/phystd/newtrelax.F90
+libf/phystd/optci.F90
+libf/phystd/optcv.F90
+libf/phystd/physiq.F90
+libf/phystd/radcommon_h.F90
+libf/phystd/radinc_h.F90
+libf/phystd/rain.F90
+libf/phystd/setspi.F90
+libf/phystd/setspv.F90
+libf/phystd/simpleprof_fn.F90
+libf/phystd/stokes.F90
 libf/phystd/suaer_corrk.F90
-libf/phystd/radcommon_h.F90
-libf/phystd/condens_co2cloud.F90
 libf/phystd/sugas_corrk.F90
-libf/phystd/def_var.F90
-libf/phystd/rain.F90
-libf/phystd/radinc_h.F90
-libf/phystd/optci.F90
-libf/phystd/mkstat.F90
-libf/phystd/setspi.F90
-libf/phystd/aeroptproperties.F90
-libf/phystd/stokes.F90
-libf/phystd/setspv.F90
+libf/phystd/su_gases.F90
+libf/phystd/su_watercycle.F90
+libf/phystd/totalcloudfrac.F90
 libf/phystd/watercommon_h.F90
+libf/phystd/watersat.F90
+libf/phystd/watersat_grad.F90
+libf/phystd/writediagsoil.F90
 libf/phystd/wstats.F90
-libf/phystd/iniwritesoil.F90
-libf/phystd/writediagsoil.F90
-libf/phystd/su_watercycle.F90
-libf/phystd/aeroptpropertiesJBnew.F90
-libf/phystd/watersat_2.F90
-libf/phystd/moistadj.F90
-libf/phystd/watersat_grad.F90
-libf/phystd/ave_stelspec.F90
-libf/phystd/calc_rayleigh.F90
-libf/phystd/calc_cpp3d.F90
